Bug 106988 - Default set of list styles
Summary: Default set of list styles
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
5.4.0.0.alpha0+
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:6.0.0 target:6.1.0 target:6.0.0.1
Keywords:
Depends on: 108697
Blocks: Bullet-Number-Outline-Lists Writer-Styles-List Writer-Toolbar-Formatting-Styles Style-Formatting-Writer-Toolbar
  Show dependency treegraph
 
Reported: 2017-04-06 12:31 UTC by Yousuf Philips (jay) (retired)
Modified: 2018-04-15 19:16 UTC (History)
11 users (show)

See Also:
Crash report or crash signature:


Attachments
The OpenSymbol PUA glyphs used for List bullets (42.37 KB, image/png)
2017-05-17 23:09 UTC, V Stuart Foote
Details
before vs after (patch) (28.25 KB, image/png)
2017-09-22 14:09 UTC, Yousuf Philips (jay) (retired)
Details
new numbering styles (9.73 KB, application/vnd.oasis.opendocument.text)
2017-09-22 14:11 UTC, Yousuf Philips (jay) (retired)
Details
numbering presets - word vs writer (32.37 KB, image/png)
2017-09-22 14:32 UTC, Yousuf Philips (jay) (retired)
Details
list styles from the eLAIX extension (10.87 KB, application/vnd.oasis.opendocument.text)
2017-09-24 20:42 UTC, Yousuf Philips (jay) (retired)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) (retired) 2017-04-06 12:31:16 UTC
By default, Writer provides 10 default list styles (5 bullet and 5 numbered styles), many of which arent useful to be used as is without modification, so it would be useful to have a good default set of list styles.

It would be good to pull this new set from the available default presets used in the bullet & numbering dialog as well as commonly used list styles from other sources like HTML/CSS[1].

= Bullets =

Current: default, dash, checkbox, arrow, checkmark
HTML: default, circle, square, none

= Number =

Current: number, number without dot, roman
HTML: number, uppercase letter, lowercase letter, uppercase roman, lowercase roman
eLAIX[2]: uppercase letter, lowercase letter, number, roman number, outline


[1] https://www.w3schools.com/html/html_lists.asp
[2] https://extensions.libreoffice.org/extensions/elaix
Comment 1 Yousuf Philips (jay) (retired) 2017-04-06 14:17:36 UTC
@Maxim, @Miklos: How difficult would it be to replace our current set of list styles with a new set? Are the current styles hard coded or are they xml imported?
Comment 2 Yousuf Philips (jay) (retired) 2017-04-06 19:43:56 UTC
MSO Bullets: default (Symbol 183), circle (Courier New 111), square (Wingding 167), image, black diamond minus white X (Wingding 118), arrow (Wingding 216), check (Wingding 252)

MSO Numbering: number, number + bracket, uppercase roman, uppercase letter, lowercase letter + bracket, lowercase letter, lowercase roman
Comment 3 Yousuf Philips (jay) (retired) 2017-05-15 12:07:06 UTC
@Stuart: Could you track down where in the code these list styles are defined?
Comment 4 Yousuf Philips (jay) (retired) 2017-05-17 15:19:17 UTC
@Regina, @Maxim, @Stuart: Could either of you track down where in the code these list styles are defined?
Comment 5 Regina Henschel 2017-05-17 16:54:37 UTC
I'm not sure, but it might be /core/sw/source/core/doc/DocumentStylePoolManager.cxx
Comment 6 Yousuf Philips (jay) (retired) 2017-05-17 21:07:43 UTC
(In reply to Regina Henschel from comment #5)
> I'm not sure, but it might be
> /core/sw/source/core/doc/DocumentStylePoolManager.cxx

Yes it is in there thanks.
Comment 7 V Stuart Foote 2017-05-17 23:09:57 UTC
Created attachment 133383 [details]
The OpenSymbol PUA glyphs used for List bullets

Yes they are in DocumentStylePoolManager.cxx but note the default font is OpenSymbol [1] where those 0xE006, 0xE004 PUA mappings have meaning.  The default had been StarSymbol, but that was recently corrected for bug 106515

None the less, the PUA glyphs used for the list styles should probably be changed over to their Unicode values, either map the PUA glyphs in OpenSymbol change the PUA to the Unicode. 

Also we might want to use a different selection of glyphs?

=-ref-=
[1] http://opengrok.libreoffice.org/xref/core/svx/source/sidebar/nbdtmg.cxx#66
Comment 8 Yousuf Philips (jay) (retired) 2017-05-17 23:26:26 UTC
Patch for new numbering list styles. - https://gerrit.libreoffice.org/37742

Ideally I would like roman numeral list styles to have their numbering alignment set to right rather than left, but wasnt able to do that as i didnt find it implemented elsewhere in the code.

(In reply to V Stuart Foote from comment #7)
> Also we might want to use a different selection of glyphs?

Instead of the existing dash and checkbox styles, we should have circle and square and they should be of similar size to the default bullet, as the current square symbol is alot bigger.
Comment 9 V Stuart Foote 2017-05-18 01:33:36 UTC
The default bullet is defined here...

http://opengrok.libreoffice.org/xref/core/sw/inc/numrule.hxx#49(In reply to Yousuf Philips (jay) from comment #8)

> 
> (In reply to V Stuart Foote from comment #7)
> > Also we might want to use a different selection of glyphs?
> 
> Instead of the existing dash and checkbox styles, we should have circle and
> square and they should be of similar size to the default bullet, as the
> current square symbol is alot bigger.

Need to be careful with this bullet list style. The style responds to indentation level.

Bullet 1 uses the x2022 "Black Small Circle" as from numrule.hxx at all levels

Bullet 2 uses the x2013 "En-dash", preferred in some locales, at all levels

Bullet 3 uses x25a1 "White square", and x2611 "Ballot box w/ Check" indent for indent

Bullet 4 uses x27a2 "Top lighted right arrow", xe006 (right arrow), xe004 (black diamond (equilateral) for indents

Bullet 5 uses x2717 "Ballot X"

To me Bullet 4 needs the work to fix OpenSymbol (move out of the PUA) and perhaps a different mix.  

Bullet 1 might be changed in numrule.hxx if we adjust OpenSymbol to provide a medium circle maybe adjusting x25cf "Black Circle" smaller or x2022 larger.

Bullet 3 might do better with x2020 "Dagger" x2021 "Double Dagger" to bring the size down.
Comment 10 Yousuf Philips (jay) (retired) 2017-05-24 16:31:15 UTC
Any recommendations on how these new numbering styles should be named or should we stick with the old naming. They used to be

Numbering 1
Numbering 2
Numbering 3
Numbering 4
Numbering 5

and i've put in a patch[1] to change them to

Numbering 1
Numbering A
Numbering a
Numbering I
Numbering i

some alternative options could be

Numbering Numerical
Numbering Numbers
Numbering 1 2 3
Numbering 1, 2, 3
--
Numbering Capital
Numbering Uppercase
Numbering Letters Uppercase
Numbering Alpha Capital
Numbering Alpha Uppercase
Numbering A B C
Numbering A, B, C
--
Numbering Non-Capital
Numbering Lowercase
Numbering Letters Lowercase
Numbering Alpha Non-Capital
Numbering Alpha Lowercase
Numbering a b c
Numbering a, b, c
--
Numbering Roman Capital
Numbering Roman Uppercase
Numbering Roman Uppercase Numbers
Numbering I II III
Numbering I, II, III
--
Numbering Roman Non-Capital
Numbering Roman Lowercase
Numbering Roman Lowercase Numbers
Numbering i ii iii
Numbering i, ii, iii

'Numbering' part of the name could also be changed to 'Number List' and we could change 'List' to 'Bullet List', so both bullet and numbering styles names look similar.

[1] in https://gerrit.libreoffice.org/#/c/37995
Comment 11 kompilainenn 2017-05-26 06:15:14 UTC
> Numbering Letters Uppercase
> Numbering Alpha Capital
> Numbering Alpha Uppercase
> --
> Numbering Letters Lowercase
> Numbering Alpha Non-Capital
> Numbering Alpha Lowercase
> --
> Numbering Roman Capital
> Numbering Roman Uppercase
> Numbering Roman Uppercase Numbers
> --
> Numbering Roman Non-Capital
> Numbering Roman Lowercase
> Numbering Roman Lowercase Numbers
> 
IMHO, these names with three word in name are too long for GUI and will problem for translating
Comment 12 Mike Kaganski 2017-05-26 06:22:32 UTC
(In reply to Yousuf Philips (jay) from comment #10)
> Numbering A
> Numbering a
> Numbering I
> Numbering i

Won't styles with names differing only with case give problems?
Comment 13 Heiko Tietze 2017-05-26 10:13:05 UTC
> Numbering Numbers
> Numbering Uppercase
> Numbering Lowercase
> Numbering Roman Uppercase
> Numbering Roman Lowercase

That looks like a good compromise. We should also think about removing "Numbering" from the text.

Another alternative

Numbering 123
Numbering ABC
Numbering abc
Numbering IVM
Numbering ivm
Comment 14 Yousuf Philips (jay) (retired) 2017-05-26 20:48:26 UTC
(In reply to kompilainenn from comment #11)
> IMHO, these names with three word in name are too long for GUI and will
> problem for translating

Yep something that long is likely useful for a tooltip.

(In reply to Mike Kaganski from comment #12)
> Won't styles with names differing only with case give problems?

Style names are case-sensitive, so i would assume not. @Maxim, @Miklos: Any thoughts?

(In reply to Heiko Tietze from comment #13)
> That looks like a good compromise. We should also think about removing
> "Numbering" from the text.

So what would distinguish bullet lists from number lists?

> Numbering 123
> Numbering ABC
> Numbering abc
> Numbering IVM
> Numbering ivm

The first three jump by 1s but the last 2 dont, which looks strange. Even if it was fine that they jump by more than 1, would have expected it to be IVX.

MS Word has outline list styles named like so, though it doesnt have any bullet and numbering styles.

1 / 1.1 / 1.1.1
1 / a / i
Comment 15 Heiko Tietze 2017-05-28 09:29:33 UTC
(In reply to Yousuf Philips (jay) from comment #14)
> > We should also think about removing "Numbering" from the text.
> So what would distinguish bullet lists from number lists?
 
* 123
* ABC
* abc
* IVX
* ivx
* Diamond
* Arrow
* Circle
* Cross
* Rectangle

(Not saying this is good.)
Comment 16 sophie 2017-05-30 15:15:37 UTC
(In reply to Heiko Tietze from comment #15)
> (In reply to Yousuf Philips (jay) from comment #14)
> > > We should also think about removing "Numbering" from the text.
> > So what would distinguish bullet lists from number lists?
>  
> * 123
> * ABC
> * abc
> * IVX
> * ivx
> * Diamond
> * Arrow
> * Circle
> * Cross
> * Rectangle
> 
> (Not saying this is good.)

I vote for this one, shorter and more readable. Only IVX/ivx are difficult to understand at the first glance. Thanks for your work :) Sophie
Comment 17 Cor Nouws 2017-08-16 21:49:10 UTC
(In reply to Heiko Tietze from comment #15)
> * 123
> * ABC
> * abc
> * IVX
> * ivx
> * Diamond
> * Arrow
> * Circle
> * Cross
> * Rectangle
> 
> (Not saying this is good.)

Fine for me, and all Dutch users.
Would that work too for e.g. Asian languages? Can they localize 1-to-1, or could they have (does the system allow this) a larger or smaller amount?
Comment 18 Commit Notification 2017-09-04 00:58:13 UTC Comment hidden (obsolete)
Comment 19 Yousuf Philips (jay) (retired) 2017-09-22 14:09:43 UTC
Created attachment 136475 [details]
before vs after (patch)

(In reply to Yousuf Philips (jay) from comment #10)
> [1] in https://gerrit.libreoffice.org/#/c/37995

So here is what the numbering styles look like from the patch, some additional tweaks are needed from a more experience dev so that the roman numberings can be right aligned and aligned at 1cm.
Comment 20 Yousuf Philips (jay) (retired) 2017-09-22 14:11:02 UTC
Created attachment 136476 [details]
new numbering styles

you can test out the new numberings from the patch in with this file
Comment 21 Yousuf Philips (jay) (retired) 2017-09-22 14:32:33 UTC
Created attachment 136477 [details]
numbering presets - word vs writer

so we need to decide which suffixes we want to append to the end of each of the numbering styles. i think going with a period after regular and roman numbers and a period or close bracket for alphabets is the best option.
Comment 22 Yousuf Philips (jay) (retired) 2017-09-24 20:42:52 UTC
Created attachment 136518 [details]
list styles from the eLAIX extension
Comment 23 Mark Hung 2017-11-17 21:11:21 UTC
Hi (In reply to Yousuf Philips (jay) from comment #10)
> Any recommendations on how these new numbering styles should be named or
> should we stick with the old naming. They used to be
> 
> Numbering 1
> Numbering 2
> Numbering 3
> Numbering 4
> Numbering 5

I prefer to stick with the old naming. A typical use case for me is to modify the numbering type to Chinese upper case and reuse the name. It needs one extra step to change the name to make it consistent. I also use the feature to define different lists ( if you have many lists in one document. ) instead of different type of list. I'd suggest to make more study on how users use the default list styles, since the opinion might varies.
Comment 24 Commit Notification 2017-11-21 12:28:14 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=3d6fca942063fe5e398c3a09f9336dc5aa549138

tdf#106988 Change default numbering list styles

It will be available in 6.0.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 25 Commit Notification 2017-12-07 21:14:56 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=74c527abc0f3b5aa0fa179401ad05a79dc889973

tdf#106988 New names for the new numbering styles

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 26 Commit Notification 2017-12-16 11:51:23 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "libreoffice-6-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=af44ee8991691b9a971901b3de36fa0e1253eac9&h=libreoffice-6-0

tdf#106988 New names for the new numbering styles

It will be available in 6.0.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 27 Timur 2018-01-04 13:06:56 UTC
AS written in Bug 83362, I'd like to have List and Numbering styles consistent with what's shown in Bullets or Numbering Style tab of Numbering Style window.
If it's 8 there like now, to have same 8 List and Numbering styles.
But why not have more, maybe 6x3=18 predefined styles, same in both places.